Get deployment template
- Base URL
-
https://api.elastic-cloud.com/api/v1
- GET /deployments/templates/{template_id}
Retrieves a deployment template by id.
Query parameters
-
show_instance_configurationsboolean · default: true -
If true, will return details for each instance configuration referenced by the template.
-
show_max_zonesboolean · default: false -
If true, will populate the max_zones field in the instance configurations. Only relevant if show_instance_configurations=true.
Responses
The deployment template was found and returned successfully.
-
deployment_templateobjectrequired -
A request for creating a new Deployment consisting of multiple clusters
-
resourcesobject -
Describes the resources that will belong to a Deployment
-
elasticsearchobject -
A list of payloads for Elasticsearch cluster creation.
-
display_namestring -
The human readable name for the cluster (defaults to the generated cluster id if not specified)
-
planobjectrequired -
The plan for the Elasticsearch cluster.
-
cluster_topologyobjectrequired -
node_typeobject -
Controls the combinations of Elasticsearch node types. TIP: By default, the Elasticsearch node is master eligible, can hold data, and run ingest pipelines. WARNING: Do not set for tiebreaker topologies.
-
node_roles -
The list of node roles for this topology element (ES version >= 7.10). Allowable values are: master, ingest, ml, data_hot, data_content, data_warm, data_cold, data_frozen, remote_cluster_client, transform
-
Values:
masteringestmldata_hotdata_contentdata_warmdata_colddata_frozenremote_cluster_clienttransform -
elasticsearchobject -
The Elasticsearch cluster settings. When specified at the top level, provides a field-by-field default. When specified at the topology level, provides the override settings.
-
versionstring -
The version of the Elasticsearch cluster (must be one of the ECE supported versions). Currently cannot be different across the topology (and is generally specified in the globals). Defaults to the latest version if not specified.
-
docker_imagestring -
A docker URI that allows overriding of the default docker image specified for this version
-
system_settingsobject -
A subset of Elasticsearch settings. TIP: To define the complete set of Elasticsearch settings, use
ElasticsearchSystemSettingswithuser_settings_override*anduser_settings*. -
scriptingobject -
Controls the languages supported by the Elasticsearch cluster, such as Painless, Mustache, and Expressions. Controls how the languages are used, such as file, index, and inline. TIP: For complex configurations, leave these blank and configure these settings in the user YAML or JSON.
-
painless_enabledboolean -
(5.x+ only) If enabled (the default) then the painless scripting engine is allowed as a sandboxed language. Sandboxed languages are the only ones allowed if 'sandbox_mode' is set to true. NOTES: (Corresponds to the parameters 'script.engine.painless.[file|stored|inline]')
-
mustache_enabledboolean -
(5.x+ only) If enabled (the default) then the mustache scripting engine is allowed as a sandboxed language. Sandboxed languages are the only ones allowed if 'sandbox_mode' is set to true. NOTES: (Corresponds to the parameters 'script.engine.mustache.[file|stored|inline]')
-
expressions_enabledboolean -
(5.x+ only) If enabled (the default) then the expressions scripting engine is allowed as a sandboxed language. Sandboxed languages are the only ones allowed if 'sandbox_mode' is set to true. NOTES: (Corresponds to the parameters 'script.engine.expression.[file|stored|inline]')
-
storedobject -
Enables scripting for the specified type and controls other parameters. Store scripts in indexes (
stored), upload in file bundles (file), or use in API requests (inline). -
enabledboolean -
If enabled (default: true) then scripts are enabled, either for sandboxing languages (by default), or for all installed languages if 'sandbox_mode' is disabled (or for 6.x). NOTES: (Corresponds to the parameter 'script.file|stored/indexed|inline')
-
sandbox_modeboolean -
If enabled (default: true) and this script type is enabled, then only the sandbox languages are allowed. By default the sandbox languages are painless, expressions and mustache, but this can be restricted via the 'painless_enabled', 'mustache_enabled' 'expression_enabled' settings.NOTES: Not supported in 6.x. (Corresponds to the parameters 'script.engine.[painless|mustache|expressions].[file|stored|inline]')
-
fileobject -
Enables scripting for the specified type and controls other parameters. Store scripts in indexes (
stored), upload in file bundles (file), or use in API requests (inline). -
enabledboolean -
If enabled (default: true) then scripts are enabled, either for sandboxing languages (by default), or for all installed languages if 'sandbox_mode' is disabled (or for 6.x). NOTES: (Corresponds to the parameter 'script.file|stored/indexed|inline')
-
sandbox_modeboolean -
If enabled (default: true) and this script type is enabled, then only the sandbox languages are allowed. By default the sandbox languages are painless, expressions and mustache, but this can be restricted via the 'painless_enabled', 'mustache_enabled' 'expression_enabled' settings.NOTES: Not supported in 6.x. (Corresponds to the parameters 'script.engine.[painless|mustache|expressions].[file|stored|inline]')
-
inlineobject -
Enables scripting for the specified type and controls other parameters. Store scripts in indexes (
stored), upload in file bundles (file), or use in API requests (inline). -
enabledboolean -
If enabled (default: true) then scripts are enabled, either for sandboxing languages (by default), or for all installed languages if 'sandbox_mode' is disabled (or for 6.x). NOTES: (Corresponds to the parameter 'script.file|stored/indexed|inline')
-
sandbox_modeboolean -
If enabled (default: true) and this script type is enabled, then only the sandbox languages are allowed. By default the sandbox languages are painless, expressions and mustache, but this can be restricted via the 'painless_enabled', 'mustache_enabled' 'expression_enabled' settings.NOTES: Not supported in 6.x. (Corresponds to the parameters 'script.engine.[painless|mustache|expressions].[file|stored|inline]')
-
reindex_whiteliststring -
Limits remote Elasticsearch clusters that can be used as the source for '_reindex' API commands
-
auto_create_indexboolean -
If true (the default), then any write operation on an index that does not currently exist will create it. NOTES: (Corresponds to the parameter 'action.auto_create_index')
-
enable_close_indexboolean -
Defaults to false on versions <= 7.2.0, true otherwise. If false, then the API commands to close indices are disabled. This is important because Elasticsearch does not snapshot or migrate close indices on versions under 7.2.0, therefore standard Elastic Cloud configuration operations will cause irretrievable loss of indices' data. NOTES: (Corresponds to the parameter 'cluster.indices.close.enable')
-
destructive_requires_nameboolean -
If true (default is false) then the index deletion API will not support wildcards or '_all'. NOTES: (Corresponds to the parameter 'action.destructive_requires_name')
-
watcher_trigger_enginestring -
The trigger engine for Watcher, defaults to 'scheduler' - see the xpack documentation for more information. NOTES: (Corresponds to the parameter '(xpack.)watcher.trigger.schedule.engine', depending on version. Ignored from 6.x onwards.)
-
default_shards_per_indexinteger · format: int32 -
(2.x only - to get the same result in 5.x template mappings must be used) Sets the default number of shards per index, defaulting to 1 if not specified. (Corresponds to the parameter 'index.number_of_shards' in 2.x, not supported in 5.x)
-
user_settings_jsonobject -
An arbitrary JSON object allowing cluster owners to set their parameters (only one of this and 'user_settings_yaml' is allowed), provided the parameters arey are on the allowlist and not on the denylist. NOTES: (This field together with 'user_settings_override*' and 'system_settings' defines the total set of Elasticsearch settings)
-
user_settings_yamlstring -
An arbitrary YAML object allowing cluster owners to set their parameters (only one of this and 'user_settings_json' is allowed), provided the parameters arey are on the allowlist and not on the denylist. NOTES: (This field together with 'user_settings_override*' and 'system_settings' defines the total set of Elasticsearch settings)
-
user_settings_override_jsonobject -
An arbitrary JSON object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_yaml' is allowed), ie in addition to the documented 'system_settings'. NOTES: (This field together with 'system_settings' and 'user_settings*' defines the total set of Elasticsearch settings)
-
user_settings_override_yamlstring -
An arbitrary YAML object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_json' is allowed), ie in addition to the documented 'system_settings'. NOTES: (This field together with 'system_settings' and 'user_settings*' defines the total set of Elasticsearch settings)
-
enabled_built_in_pluginsstring -
A list of plugin names from the Elastic-supported subset that are bundled with the version images. NOTES: (Users should consult the Elastic stack objects to see what plugins are available, this is currently only available from the UI)
-
user_bundlesobject -
A list of admin-uploaded bundle objects (eg scripts, synonym files) that are available for this user.
-
instance_configuration_idstring -
Controls the allocation of this topology element as well as allowed sizes and node_types. It needs to match the id of an existing instance configuration.
-
instance_configuration_versioninteger · format: int32 -
The version of the Instance Configuration Id. If it is unset, the meaning depends on read vs writes. For deployment reads, it is equivalent to version 0 (or the IC is unversioned); for deployment creates and deployment template use, it is equivalent to 'the latest version'; and for deployment updates, it is equivalent to 'retain the current version'.
-
sizeobject -
Measured by the amount of a resource. The final cluster size is calculated using multipliers from the topology instance configuration.
-
autoscaling_minobject -
Measured by the amount of a resource. The final cluster size is calculated using multipliers from the topology instance configuration.
-
autoscaling_maxobject -
Measured by the amount of a resource. The final cluster size is calculated using multipliers from the topology instance configuration.
-
autoscaling_policy_override_jsonobject -
An arbitrary JSON object overriding the default autoscaling policy. Don't set unless you really know what you are doing.
-
topology_element_controlobject -
Controls for the topology element. Only used as part of the deployment template. Ignored if included as part of a deployment.
-
autoscaling_tier_overrideboolean -
Set to true to enable autoscaling for this topology element, even if the cluster-level 'autoscaling_enabled' field is false. Note that 'autoscaling_tier_override' cannot be set to false if cluster-level 'autoscaling_enabled' is true. Currently only supported for the 'ml' tier
-
elasticsearchobjectrequired -
The Elasticsearch cluster settings. When specified at the top level, provides a field-by-field default. When specified at the topology level, provides the override settings.
-
transientobject -
Defines the configuration parameters that control how the plan is applied. For example, the Elasticsearch cluster topology and Elasticsearch settings.
-
strategyobject -
The options for performing a plan change. Specify only one property each time. The default is
grow_and_shrink. -
rollingobject -
Performs inline, rolling configuration changes that mutate existing containers. TIP: This is the fastest way to update a plan, but can fail for complex plan changes, such as topology changes. Also, this is less safe for configuration changes that leave a cluster in a non running state. NOTE: When you perform a major version upgrade, and 'group_by' is set to 'pass:macros[all]';, rolling is required.
-
group_bystring -
Specifies the grouping attribute to use when rolling several instances. Instances that share the same value for the provided attribute key are rolled together as a unit. Examples that make sense to use are '__all__' (roll all instances as a single unit), 'logical_zone_name' (roll instances by zone), '__name__' (roll one instance at a time, the default if not specified). Note that '__all__' is required when performing a major version upgrade
-
allow_inline_resizeboolean -
Whether we allow changing the capacity of instances (default false). This is currently implemented by stopping, re-creating then starting the affected instance on its associated allocator when performing the changes. NOTES: This requires a round-trip through the allocation infrastructure of the active constructor, as it has to reserve the target capacity without over-committing
-
grow_and_shrinkobject -
A strategy that creates instances with the new plan, migrates data from the old instances, then shuts down the old instances.
GrowShrinkStrategyConfigis safer than 'rolling' and ensures single node availability during a plan change, but can be a lot slower on larger clusters. -
plan_configurationobject -
The configuration settings for the timeout and fallback parameters.
-
timeoutinteger · format: int64 -
The total timeout in seconds after which the plan is cancelled even if it is not complete. Defaults to 4x the max memory capacity per node (in MB). NOTES: A 3 zone cluster with 2 nodes of 2048 each would have a timeout of 4*2048=8192 seconds. Timeout does not include time required to run rollback actions.
-
calm_wait_timeinteger · format: int64 -
This timeout determines how long to give a cluster after it responds to API calls before performing actual operations on it. It defaults to 5s
-
skip_snapshotboolean -
If true (default: false), does not take (or require) a successful snapshot to be taken before performing any potentially destructive changes to this cluster
-
max_snapshot_attemptsinteger · format: int32 -
If taking a snapshot (ie unless 'skip_snapshots': true) then will retry on failure at most this number of times (default: 5)
-
max_snapshot_ageinteger · format: int64 -
When you take a snapshot and 'skip_snapshots' is false, specifies the maximum age in seconds of the most recent snapshot before a new snapshot is created. Default is 300
-
extended_maintenanceboolean -
If true (default false), does not clear the maintenance flag (which prevents its API from being accessed except by the constructor) on new instances added until after a snapshot has been restored, otherwise, the maintenance flag is cleared once the new instances successfully join the new cluster
-
restore_snapshotobject -
Restores a snapshot from a local or remote repository.
-
repository_namestring -
If specified, contains the name of the snapshot repository - else will default to the Elastic Cloud system repo ('found-snapshots')
-
snapshot_namestringrequired -
The name of the snapshot to restore. Use '__latest_success__' to get the most recent snapshot from the specified repository
-
repository_configobject -
Configures the location of a remote repository. The default is the system repository.
-
restore_payloadobject -
The configuration for the restore command, such as which indices you want to restore.
-
snapshot_dependencyobject -
Configuration for attaching a snapshot repository dependency from another cluster. This creates a snapshot repository in the target cluster pointing to the source cluster's snapshots.
-
remote_clustersobject -
The list of resources used as remote clusters
-
resourcesobjectrequired -
The remote resources
-
elasticsearch_ref_idstringrequired -
The locally-unique user-specified id of an Elasticsearch Resource
-
aliasstringrequired -
The alias for this remote cluster. Aliases must only contain letters, digits, dashes and underscores
-
If true, skip this cluster during search if it is disconnected. Default: false
-
cluster_settings_jsonobject -
If specified, contains transient settings to be applied to an Elasticsearch cluster during changes,default values shown below applied. These can be overridden by specifying them in the map (or null to unset). Additional settings can also be set. Settings will be cleared after the plan has finished. If not specified, no settings will be applied. NOTE: These settings are only explicitly cleared for 5.x+ clusters, they must be hand-reset to their defaults in 2.x- (or a cluster reboot will clear them).
- indices.store.throttle.max_bytes_per_sec: 120Mb
- indices.recovery.max_bytes_per_sec: 120Mb
- cluster.routing.allocation.cluster_concurrent_rebalance: 5
- cluster.routing.allocation.node_initial_primaries_recoveries: 5
- cluster.routing.allocation.node_concurrent_incoming_recoveries: 5 For version 8.1 and later no defaults are provided through this mechanism, but instead hardware dependent settings are provided to each instance.
-
settingsobject -
The settings for an Elasticsearch cluster.
-
dedicated_masters_thresholdinteger · format: int32 -
Threshold starting from which the number of instances in the cluster results in the introduction of dedicated masters. If the cluster is downscaled to a number of nodes below this one, dedicated masters will be removed. Limit is inclusive. When provided the threshold setting is updated. A
nullvalue removes the field. Otherwise, the setting remains as it was set previously. -
trustobject -
Configuration of trust with other clusters.
-
directobject -
The list of trust relationships where the certificate is bundled with the trust setting. Allows configuring trust for clusters running outside of an Elastic Cloud managed environment or in an Elastic Cloud environment without an environment level trust established.
-
uidstring -
Auto generated identifier for this trust, allows distinguishing between update vs remove and add.
-
type -
The type can either be ESS, ECE, generic or proxy. If none is specified, then generic is assumed. If proxy is specified, trust_all should be false and trust_allowlist, scope_id and additional_node_names should be omitted.
-
Values:
ECEESSgenericproxy -
trust_allbooleanrequired -
If true, scope_id is required and the
trust_allowlistis ignored and all clusters matching the scope id will be trusted. -
trust_allowliststring -
The list of clusters with matching scope to trust. Only used when
trust_allis false. Providing one or more clusters makes scope_id mandatory. -
scope_idstring -
A lowercase alphanumerical string of max 32 characters. Usually an organization id or an environment id, but could really be any suitable suffix for clusters using the CA certificate of this trust. Required unless trust_all is false and trust_allowlist is empty.
-
additional_node_namesstring -
A list of node names trusted in addition to those deducible from trust_allowlist and scope id. Allows trusting nodes that don't have a scoped name at the cost of maintaining the list. Mandatory if scope id is not defined. Wildcards are not allowed.
-
keystore_contentsobject -
The contents of the Elasticsearch keystore.
-
secretsmap string to objectrequired -
List of secrets
-
<string>object -
valueobject -
Value of this setting. This can either be a string or a JSON object that is stored as a JSON string in the keystore. NOTE: When the keystore secret is unspecified, it is removed.
-
as_fileboolean -
Stores the keystore secret as a file. The default is false, which stores the keystore secret as string when value is a plain string, or true when value is an object.
-
kibanaobject -
A list of payloads for Kibana creation.
-
display_namestring -
The human readable name for the Kibana cluster (default: takes the name of its Elasticsearch cluster)
-
planobjectrequired -
The plan for the Kibana instance.
-
cluster_topologyobject -
instance_configuration_idstring -
Controls the allocation of this topology element as well as allowed sizes and node_types. It needs to match the id of an existing instance configuration.
-
instance_configuration_versioninteger · format: int32 -
The version of the Instance Configuration Id. If it is unset, the meaning depends on read vs writes. For deployment reads, it is equivalent to version 0 (or the IC is unversioned); for deployment creates and deployment template use, it is equivalent to 'the latest version'; and for deployment updates, it is equivalent to 'retain the current version'.
-
sizeobject -
Measured by the amount of a resource. The final cluster size is calculated using multipliers from the topology instance configuration.
-
kibanaobject -
The Kibana instance settings. When specified at the top level, provides a field-by-field default. When specified at the topology level, provides the override settings.
-
versionstring -
The version of the Kibana cluster (must be one of the ECE supported versions, and won't work unless it matches the Elasticsearch version. Leave blank to auto-detect version.)
-
docker_imagestring -
A docker URI that allows overriding of the default docker image specified for this version
-
system_settingsobject -
A subset of Kibana settings. TIP: To define the complete set of Elasticsearch settings, use
KibanaSystemSettingswithuser_settings_override_anduser_settings_. -
user_settings_jsonobject -
An arbitrary JSON object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_yaml' is allowed), provided the parameters are on the allowlist and not on the denylist. (This field together with 'user_settings_override*' and 'system_settings' defines the total set of Kibana settings)
-
user_settings_yamlstring -
An arbitrary YAML object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_json' is allowed), provided the parameters are on the allowlist and not on the denylist. (These field together with 'user_settings_override*' and 'system_settings' defines the total set of Kibana settings)
-
user_settings_override_jsonobject -
An arbitrary JSON object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_yaml' is allowed), ie in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of Kibana settings)
-
user_settings_override_yamlstring -
An arbitrary YAML object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_json' is allowed), ie in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of Kibana settings)
-
kibanaobjectrequired -
The Kibana instance settings. When specified at the top level, provides a field-by-field default. When specified at the topology level, provides the override settings.
-
versionstring -
The version of the Kibana cluster (must be one of the ECE supported versions, and won't work unless it matches the Elasticsearch version. Leave blank to auto-detect version.)
-
docker_imagestring -
A docker URI that allows overriding of the default docker image specified for this version
-
system_settingsobject -
A subset of Kibana settings. TIP: To define the complete set of Elasticsearch settings, use
KibanaSystemSettingswithuser_settings_override_anduser_settings_. -
user_settings_jsonobject -
An arbitrary JSON object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_yaml' is allowed), provided the parameters are on the allowlist and not on the denylist. (This field together with 'user_settings_override*' and 'system_settings' defines the total set of Kibana settings)
-
user_settings_yamlstring -
An arbitrary YAML object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_json' is allowed), provided the parameters are on the allowlist and not on the denylist. (These field together with 'user_settings_override*' and 'system_settings' defines the total set of Kibana settings)
-
user_settings_override_jsonobject -
An arbitrary JSON object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_yaml' is allowed), ie in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of Kibana settings)
-
user_settings_override_yamlstring -
An arbitrary YAML object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_json' is allowed), ie in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of Kibana settings)
-
transientobject -
Defines the configuration parameters that control how the plan is applied. For example, the Elasticsearch cluster topology and Kibana instance settings.
-
strategyobject -
The options for performing a plan change. Specify only one property each time. The default is
grow_and_shrink. -
rollingobject -
Performs inline, rolling configuration changes that mutate existing containers. TIP: This is the fastest way to update a plan, but can fail for complex plan changes, such as topology changes. Also, this is less safe for configuration changes that leave a cluster in a non running state. NOTE: When you perform a major version upgrade, and 'group_by' is set to 'pass:macros[all]';, rolling is required.
-
group_bystring -
Specifies the grouping attribute to use when rolling several instances. Instances that share the same value for the provided attribute key are rolled together as a unit. Examples that make sense to use are '__all__' (roll all instances as a single unit), 'logical_zone_name' (roll instances by zone), '__name__' (roll one instance at a time, the default if not specified). Note that '__all__' is required when performing a major version upgrade
-
allow_inline_resizeboolean -
Whether we allow changing the capacity of instances (default false). This is currently implemented by stopping, re-creating then starting the affected instance on its associated allocator when performing the changes. NOTES: This requires a round-trip through the allocation infrastructure of the active constructor, as it has to reserve the target capacity without over-committing
-
grow_and_shrinkobject -
A strategy that creates instances with the new plan, migrates data from the old instances, then shuts down the old instances.
GrowShrinkStrategyConfigis safer than 'rolling' and ensures single node availability during a plan change, but can be a lot slower on larger clusters. -
plan_configurationobject -
The configuration settings for the timeout and fallback parameters.
-
timeoutinteger · format: int64 -
The total timeout in seconds after which the plan is cancelled even if it is not complete. Defaults to 4x the max memory capacity per node (in MB)
-
calm_wait_timeinteger · format: int64 -
This timeout determines how long to give a cluster after it responds to API calls before performing actual operations on it. It defaults to 5s
-
extended_maintenanceboolean -
If true (default false), does not clear the maintenance flag (which prevents its API from being accessed except by the constructor) on new instances added until after a snapshot has been restored, otherwise, the maintenance flag is cleared once the new instances successfully join the new cluster
-
apmobject -
A list of payloads for APM creation. WARNING: For stack versions 8.0.0 and higher the integrations_server payload should be used instead, as this field becomes deprecated.
-
display_namestring -
The human readable name for the APM cluster (default: takes the name of its Elasticsearch cluster)
-
planobjectrequired -
The plan for the APM Server.
-
cluster_topologyobject -
instance_configuration_idstring -
Controls the allocation of this topology element as well as allowed sizes and node_types. It needs to match the id of an existing instance configuration.
-
instance_configuration_versioninteger · format: int32 -
The version of the Instance Configuration Id. If it is unset, the meaning depends on read vs writes. For deployment reads, it is equivalent to version 0 (or the IC is unversioned); for deployment creates and deployment template use, it is equivalent to 'the latest version'; and for deployment updates, it is equivalent to 'retain the current version'.
-
sizeobject -
Measured by the amount of a resource. The final cluster size is calculated using multipliers from the topology instance configuration.
-
apmobject -
The configuration options for the APM Server.
-
versionstring -
The version of the Apm cluster (must be one of the ECE supported versions, and won't work unless it matches the APM version. Leave blank to auto-detect version.)
-
docker_imagestring -
A docker URI that allows overriding of the default docker image specified for this version
-
system_settingsobject -
A structure that defines a curated subset of the APM Server settings. TIP: To define the complete set of APM Server setting, use
ApmSystemSettingswithuser_settings_override_anduser_settings_. -
elasticsearch_usernamestring -
Optionally override the account within APM - defaults to a system account that always exists (if specified, the password must also be specified). Note that this field is never returned from the API, it is write only.
-
elasticsearch_passwordstring -
Optionally override the account within APM - defaults to a system account that always exists (if specified, the username must also be specified). Note that this field is never returned from the API, it is write only.
-
user_settings_jsonobject -
An arbitrary JSON object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_yaml' is allowed), provided the parameters are on the allowlist and not on the denylist. (This field together with 'user_settings_override*' and 'system_settings' defines the total set of Apm settings)
-
user_settings_yamlstring -
An arbitrary YAML object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_json' is allowed), provided the parameters are on the allowlist and not on the denylist. (These field together with 'user_settings_override*' and 'system_settings' defines the total set of Apm settings)
-
user_settings_override_jsonobject -
An arbitrary JSON object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_yaml' is allowed), ie in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of Apm settings)
-
user_settings_override_yamlstring -
An arbitrary YAML object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_json' is allowed), ie in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of Apm settings)
-
transientobject -
Defines the configuration parameters that control how the plan is applied. For example, the Elasticsearch cluster topology and APM Server settings.
-
strategyobject -
The options for performing a plan change. Specify only one property each time. The default is
grow_and_shrink. -
rollingobject -
Performs inline, rolling configuration changes that mutate existing containers. TIP: This is the fastest way to update a plan, but can fail for complex plan changes, such as topology changes. Also, this is less safe for configuration changes that leave a cluster in a non running state. NOTE: When you perform a major version upgrade, and 'group_by' is set to 'pass:macros[all]';, rolling is required.
-
group_bystring -
Specifies the grouping attribute to use when rolling several instances. Instances that share the same value for the provided attribute key are rolled together as a unit. Examples that make sense to use are '__all__' (roll all instances as a single unit), 'logical_zone_name' (roll instances by zone), '__name__' (roll one instance at a time, the default if not specified). Note that '__all__' is required when performing a major version upgrade
-
allow_inline_resizeboolean -
Whether we allow changing the capacity of instances (default false). This is currently implemented by stopping, re-creating then starting the affected instance on its associated allocator when performing the changes. NOTES: This requires a round-trip through the allocation infrastructure of the active constructor, as it has to reserve the target capacity without over-committing
-
grow_and_shrinkobject -
A strategy that creates instances with the new plan, migrates data from the old instances, then shuts down the old instances.
GrowShrinkStrategyConfigis safer than 'rolling' and ensures single node availability during a plan change, but can be a lot slower on larger clusters. -
plan_configurationobject -
The plan control configuration options for the APM Server.
-
timeoutinteger · format: int64 -
The total timeout in seconds after which the plan is cancelled even if it is not complete. Defaults to 4x the max memory capacity per node (in MB)
-
calm_wait_timeinteger · format: int64 -
This timeout determines how long to give a cluster after it responds to API calls before performing actual operations on it. It defaults to 5s
-
extended_maintenanceboolean -
If true (default false), does not clear the maintenance flag (which prevents its API from being accessed except by the constructor) on new instances added until after a snapshot has been restored, otherwise, the maintenance flag is cleared once the new instances successfully join the new cluster
-
appsearchobject -
A list of payloads for AppSearch updates. AppSearch has been replaced by Enterprise Search in the Elastic Stack 7.7 and higher.
-
elasticsearch_cluster_ref_idstringrequired -
Alias to the Elasticsearch Cluster to attach AppSearch to
-
display_namestring -
The human readable name for the AppSearch cluster (default: takes the name of its Elasticsearch cluster)
-
planobjectrequired -
The plan for the App Search cluster.
-
cluster_topologyobject -
instance_configuration_idstring -
Controls the allocation of this topology element as well as allowed sizes and node_types. It needs to match the id of an existing instance configuration.
-
instance_configuration_versioninteger · format: int32 -
The version of the Instance Configuration Id. If it is unset, the meaning depends on read vs writes. For deployment reads, it is equivalent to version 0 (or the IC is unversioned); for deployment creates and deployment template use, it is equivalent to 'the latest version'; and for deployment updates, it is equivalent to 'retain the current version'.
-
sizeobject -
Measured by the amount of a resource. The final cluster size is calculated using multipliers from the topology instance configuration.
-
appsearchobject -
versionstring -
The version of the AppSearch cluster (must be one of the ECE supported versions, and won't work unless it matches the Elasticsearch version. Leave blank to auto-detect version.)
-
docker_imagestring -
A docker URI that allows overriding of the default docker image specified for this version
-
system_settingsobject -
This structure defines a curated subset of the AppSearch settings. (This field together with 'user_settings_override*' and 'user_settings*' defines the total set of AppSearch settings)
-
elasticsearch_urlstring -
Optionally override the URL to which to send data (for advanced users only, if unspecified the system selects an internal URL)
-
elasticsearch_usernamestring -
Optionally override the account within App Search - defaults to a system account that always exists (if specified, the password must also be specified). Note that this field is never returned from the API, it is write only.
-
user_settings_jsonobject -
An arbitrary JSON object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_yaml' is allowed), provided the parameters are on the allowlist and not on the denylist. (This field together with 'user_settings_override*' and 'system_settings' defines the total set of AppSearch settings)
-
user_settings_yamlstring -
An arbitrary YAML object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_json' is allowed), provided the parameters are on the allowlist and not on the denylist. (These field together with 'user_settings_override*' and 'system_settings' defines the total set of AppSearch settings)
-
user_settings_override_jsonobject -
An arbitrary JSON object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_yaml' is allowed), ie in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of AppSearch settings)
-
user_settings_override_yamlstring -
An arbitrary YAML object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_json' is allowed), ie in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of AppSearch settings)
-
transientobject -
Defines configuration parameters that control how the plan (ie consisting of the cluster topology and AppSearch settings) is applied
-
strategyobject -
The options for performing a plan change. Specify only one property each time. The default is
grow_and_shrink. -
rollingobject -
Performs inline, rolling configuration changes that mutate existing containers. TIP: This is the fastest way to update a plan, but can fail for complex plan changes, such as topology changes. Also, this is less safe for configuration changes that leave a cluster in a non running state. NOTE: When you perform a major version upgrade, and 'group_by' is set to 'pass:macros[all]';, rolling is required.
-
group_bystring -
Specifies the grouping attribute to use when rolling several instances. Instances that share the same value for the provided attribute key are rolled together as a unit. Examples that make sense to use are '__all__' (roll all instances as a single unit), 'logical_zone_name' (roll instances by zone), '__name__' (roll one instance at a time, the default if not specified). Note that '__all__' is required when performing a major version upgrade
-
allow_inline_resizeboolean -
Whether we allow changing the capacity of instances (default false). This is currently implemented by stopping, re-creating then starting the affected instance on its associated allocator when performing the changes. NOTES: This requires a round-trip through the allocation infrastructure of the active constructor, as it has to reserve the target capacity without over-committing
-
grow_and_shrinkobject -
A strategy that creates instances with the new plan, migrates data from the old instances, then shuts down the old instances.
GrowShrinkStrategyConfigis safer than 'rolling' and ensures single node availability during a plan change, but can be a lot slower on larger clusters. -
plan_configurationobject -
timeoutinteger · format: int64 -
The total timeout in seconds after which the plan is cancelled even if it is not complete. Defaults to 4x the max memory capacity per node (in MB)
-
calm_wait_timeinteger · format: int64 -
This timeout determines how long to give a cluster after it responds to API calls before performing actual operations on it. It defaults to 5s
-
reallocate_instancesboolean -
If true (default: false) does not allow re-using any existing instances currently in the cluster, ie even unchanged instances will be re-created
-
preferred_allocatorsstring -
List of allocators on which instances are placed if possible (if not possible/not specified then any available allocator with space is used)
-
extended_maintenanceboolean -
If true (default false), does not clear the maintenance flag (which prevents its API from being accessed except by the constructor) on new instances added until after a snapshot has been restored, otherwise, the maintenance flag is cleared once the new instances successfully join the new cluster
-
enterprise_searchobject -
A list of payloads for Enterprise Search creation.
-
elasticsearch_cluster_ref_idstringrequired -
Alias to the Elasticsearch Cluster to attach Enterprise Search to
-
display_namestring -
The human readable name for the Enterprise Search cluster (default: takes the name of its Elasticsearch cluster)
-
planobjectrequired -
The plan for the Enterprise Search cluster.
-
cluster_topologyobject -
instance_configuration_idstring -
Controls the allocation of this topology element as well as allowed sizes and node_types. It needs to match the id of an existing instance configuration.
-
instance_configuration_versioninteger · format: int32 -
The version of the Instance Configuration Id. If it is unset, the meaning depends on read vs writes. For deployment reads, it is equivalent to version 0 (or the IC is unversioned); for deployment creates and deployment template use, it is equivalent to 'the latest version'; and for deployment updates, it is equivalent to 'retain the current version'.
-
sizeobject -
Measured by the amount of a resource. The final cluster size is calculated using multipliers from the topology instance configuration.
-
enterprise_searchobject -
versionstring -
The version of the Enterprise Search cluster (must be one of the ECE supported versions, and won't work unless it matches the Elasticsearch version. Leave blank to auto-detect version.)
-
docker_imagestring -
A docker URI that allows overriding of the default docker image specified for this version
-
system_settingsobject -
This structure defines a curated subset of the Enterprise Search settings. (This field together with 'user_settings_override*' and 'user_settings*' defines the total set of Enterprise Search settings)
-
user_settings_jsonobject -
An arbitrary JSON object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_yaml' is allowed), provided the parameters are on the allowlist and not on the denylist. (This field together with 'user_settings_override*' and 'system_settings' defines the total set of Enterprise Search settings)
-
user_settings_yamlstring -
An arbitrary YAML object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_json' is allowed), provided the parameters are on the allowlist and not on the denylist. (This field together with 'user_settings_override*' and 'system_settings' defines the total set of Enterprise Search settings)
-
user_settings_override_jsonobject -
An arbitrary JSON object allowing ECE admins to set clusters' parameters (only one of this and 'user_settings_override_yaml' is allowed), i.e. in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of Enterprise Search settings)
-
user_settings_override_yamlstring -
An arbitrary YAML object allowing ECE admins to set clusters' parameters (only one of this and 'user_settings_override_json' is allowed), i.e. in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of Enterprise Search settings)
-
transientobject -
Defines configuration parameters that control how the plan (i.e. consisting of the cluster topology and Enterprise Search settings) is applied
-
strategyobject -
The options for performing a plan change. Specify only one property each time. The default is
grow_and_shrink. -
rollingobject -
Performs inline, rolling configuration changes that mutate existing containers. TIP: This is the fastest way to update a plan, but can fail for complex plan changes, such as topology changes. Also, this is less safe for configuration changes that leave a cluster in a non running state. NOTE: When you perform a major version upgrade, and 'group_by' is set to 'pass:macros[all]';, rolling is required.
-
group_bystring -
Specifies the grouping attribute to use when rolling several instances. Instances that share the same value for the provided attribute key are rolled together as a unit. Examples that make sense to use are '__all__' (roll all instances as a single unit), 'logical_zone_name' (roll instances by zone), '__name__' (roll one instance at a time, the default if not specified). Note that '__all__' is required when performing a major version upgrade
-
allow_inline_resizeboolean -
Whether we allow changing the capacity of instances (default false). This is currently implemented by stopping, re-creating then starting the affected instance on its associated allocator when performing the changes. NOTES: This requires a round-trip through the allocation infrastructure of the active constructor, as it has to reserve the target capacity without over-committing
-
grow_and_shrinkobject -
A strategy that creates instances with the new plan, migrates data from the old instances, then shuts down the old instances.
GrowShrinkStrategyConfigis safer than 'rolling' and ensures single node availability during a plan change, but can be a lot slower on larger clusters. -
plan_configurationobject -
timeoutinteger · format: int64 -
The total timeout in seconds after which the plan is cancelled even if it is not complete. Defaults to 4x the max memory capacity per node (in MB)
-
calm_wait_timeinteger · format: int64 -
This timeout determines how long to give a cluster after it responds to API calls before performing actual operations on it. It defaults to 5s
-
reallocate_instancesboolean -
If true (default: false) does not allow re-using any existing instances currently in the cluster, i.e. even unchanged instances will be re-created
-
preferred_allocatorsstring -
List of allocators on which instances are placed if possible (if not possible/not specified then any available allocator with space is used)
-
extended_maintenanceboolean -
If true (default false), does not clear the maintenance flag (which prevents its API from being accessed except by the constructor) on new instances added until after a snapshot has been restored, otherwise, the maintenance flag is cleared once the new instances successfully join the new cluster
-
integrations_serverobject -
A list of payloads for Integrations Server creation.
-
elasticsearch_cluster_ref_idstringrequired -
Alias to the Elasticsearch Cluster to attach the Integrations Server to
-
display_namestring -
The human readable name for the Integrations Server cluster (default: takes the name of its Elasticsearch cluster)
-
planobjectrequired -
The plan for the Integrations Server.
-
cluster_topologyobject -
instance_configuration_idstring -
Controls the allocation of this topology element as well as allowed sizes and node_types. It needs to match the id of an existing instance configuration.
-
instance_configuration_versioninteger · format: int32 -
The version of the Instance Configuration Id. If it is unset, the meaning depends on read vs writes. For deployment reads, it is equivalent to version 0 (or the IC is unversioned); for deployment creates and deployment template use, it is equivalent to 'the latest version'; and for deployment updates, it is equivalent to 'retain the current version'.
-
sizeobject -
Measured by the amount of a resource. The final cluster size is calculated using multipliers from the topology instance configuration.
-
integrations_serverobject -
The configuration options for the Integrations Server.
-
versionstring -
The version of the Integrations Server cluster (must be one of the ECE supported versions, and won't work unless it matches the Integrations Server version. Leave blank to auto-detect version.)
-
docker_imagestring -
A docker URI that allows overriding of the default docker image specified for this version
-
system_settingsobject -
A structure that defines a curated subset of the Integrations Server settings. TIP: To define the complete set of Integrations Server setting, use
IntegrationsSystemSettingswithuser_settings_override_anduser_settings_. -
elasticsearch_usernamestring -
Optionally override the account within Integrations Server - defaults to a system account that always exists (if specified, the password must also be specified). Note that this field is never returned from the API, it is write only.
-
elasticsearch_passwordstring -
Optionally override the account within Integrations Server - defaults to a system account that always exists (if specified, the username must also be specified). Note that this field is never returned from the API, it is write only.
-
user_settings_jsonobject -
An arbitrary JSON object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_yaml' is allowed), provided the parameters are on the allowlist and not on the denylist. (This field together with 'user_settings_override*' and 'system_settings' defines the total set of Integrations Server settings)
-
user_settings_yamlstring -
An arbitrary YAML object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_json' is allowed), provided the parameters are on the allowlist and not on the denylist. (These field together with 'user_settings_override*' and 'system_settings' defines the total set of Integrations Server settings)
-
user_settings_override_jsonobject -
An arbitrary JSON object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_yaml' is allowed), ie in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of Integrations Server settings)
-
user_settings_override_yamlstring -
An arbitrary YAML object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_json' is allowed), ie in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of Integrations Server settings)
-
transientobject -
Defines the configuration parameters that control how the plan is applied. For example, the Elasticsearch cluster topology and Integrations Server settings.
-
strategyobject -
The options for performing a plan change. Specify only one property each time. The default is
grow_and_shrink. -
rollingobject -
Performs inline, rolling configuration changes that mutate existing containers. TIP: This is the fastest way to update a plan, but can fail for complex plan changes, such as topology changes. Also, this is less safe for configuration changes that leave a cluster in a non running state. NOTE: When you perform a major version upgrade, and 'group_by' is set to 'pass:macros[all]';, rolling is required.
-
group_bystring -
Specifies the grouping attribute to use when rolling several instances. Instances that share the same value for the provided attribute key are rolled together as a unit. Examples that make sense to use are '__all__' (roll all instances as a single unit), 'logical_zone_name' (roll instances by zone), '__name__' (roll one instance at a time, the default if not specified). Note that '__all__' is required when performing a major version upgrade
-
allow_inline_resizeboolean -
Whether we allow changing the capacity of instances (default false). This is currently implemented by stopping, re-creating then starting the affected instance on its associated allocator when performing the changes. NOTES: This requires a round-trip through the allocation infrastructure of the active constructor, as it has to reserve the target capacity without over-committing
-
grow_and_shrinkobject -
A strategy that creates instances with the new plan, migrates data from the old instances, then shuts down the old instances.
GrowShrinkStrategyConfigis safer than 'rolling' and ensures single node availability during a plan change, but can be a lot slower on larger clusters. -
plan_configurationobject -
The plan control configuration options for the Integrations Server.
-
timeoutinteger · format: int64 -
The total timeout in seconds after which the plan is cancelled even if it is not complete. Defaults to 4x the max memory capacity per node (in MB)
-
calm_wait_timeinteger · format: int64 -
This timeout determines how long to give a cluster after it responds to API calls before performing actual operations on it. It defaults to 5s
-
extended_maintenanceboolean -
If true (default false), does not clear the maintenance flag (which prevents its API from being accessed except by the constructor) on new instances added until after a snapshot has been restored, otherwise, the maintenance flag is cleared once the new instances successfully join the new cluster
-
settingsobject -
Additional configuration for the new deployment object.
-
metadataobject -
Additional information about the new deployment object.
-
Arbitrary user-defined metadata associated with this deployment
-
The metadata field name
-
The metadata value
-
instance_configurationsobjectrequired -
List of instance configurations used in the cluster template.
-
config_versioninteger · format: int32 -
If the IC is configuration controlled, this field is the version either being read back (reads return the latest IC unless specified by the 'config_version' URL param), or the version to update. Cannot be used in creates. For unversioned IC reads it is left empty.
-
instance_type -
The type of instance. For instance configurations where the type is specified in the 'id', the default value of 'instance_type' will be automatically inferred.
-
Values:
elasticsearchkibanaapmintegrations_serverappsearchenterprise_search -
node_typesstring -
Node types (master, data) for the instance. For instance configurations where the type (and tier) is specified in the 'id', the default value of 'node_types' will be automatically inferred.
-
orderinteger · format: int32 -
Determines the order in which this template should be returned when listed. Templates are returned in ascending order. If not specified, then the template willbe appended to the end of the list.
The requested region is not supported. (code: templates.region_not_found)
The user is not authorized to access requested region. (code: templates.region_not_allowed)
The deployment template specified by {template_id} cannot be found. (code: templates.template_not_found)